       IDENTIFICATION DIVISION.
       PROGRAM-ID.    SMSGHDO2                                          C123840
      ******************************************************************
      *C123840 : MESSAGE PROPERTIES FILE FOR THE CONSUMER FRAMEWORK *** C123840
      *detect the presense of a new parameter.                          C123840
      * When the new parameter                                          C123840
      * is detected the application will open and read the new message  C123840
      * properties file.  The name value pairs contained in the message C123840
      * properties file will be used in the MQ API calls to build the   C123840
      * required message properties. In addtion code will be added to   C123840
      * issue the MQ API to delete the message properties when          C123840
      * appropriate.                                                    C123840
      ******************************************************************C123840
       ENVIRONMENT DIVISION.
       INPUT-OUTPUT SECTION.                                            C123480
       FILE-CONTROL.                                                    C123480
       DATA DIVISION.
       FILE SECTION.
      *BT COPY SVCMSPR1.                                                C123480

       WORKING-STORAGE SECTION.

       77  WS-SMSGHLDO-BEGIN            PIC X(36) VALUE
           'SMSGHLDO WORKING STORAGE BEGINS HERE'.
      *BTS
       01  WS-PROP-NAME                PIC X(25) VALUE SPACES.          C123840
       01  WS-MISC-FIELDS.                                              C32988
           05  WS-I1                   PIC S9(4)   COMP VALUE ZEROS.    C123840
           05  WS-MESSAGE-HANDLE       PIC S9(18) BINARY VALUE ZERO.    C123840
           05 WS-PROPERTY-VALUE-LNTH      PIC S9(9) BINARY VALUE ZEROS. C123840
       01  MQM-CRT-MSG-HNDLE-OPTIONS.                                   C123840
           COPY CMQCMHOV.                                               C123840
       01  MQM-SET-MESSAGE-OPTIONS.                                     C123840
           COPY CMQSMPOV.                                               C123840
       01  MQM-SET-PROPERTY-NAME.                                       C123840
           COPY CMQCHRVV.                                               C123840
       01  MQM-SET-PROPERTY-DESCRIPTOR.                                 C123840
           COPY CMQPDV.                                                 C123840
       01  MQM-DELETE-MESSPROP-OPTIONS.                                 C123840
           COPY CMQDMPOV.                                               C123840


       01  WS-SMSGHLDO-END             PIC X(34) VALUE
           'SMSGHLDO WORKING STORAGE ENDS HERE'.

       LINKAGE SECTION.

           EJECT
      *BTS
       PROCEDURE DIVISION USING BATCH-CONSUMER,
                                WS-MQPUT-MESSAGE,
                                WS-SOAPRESP-MSG-LEN,
                                OUT-MQ-INFO,
                                GET-MQ-INFO,
                                OUTMSG-ID,
                                ErrorInfo,                              C44051
                                SVCNBT01,
                                SERVICE-MESG-PROP.                      C123840
      *BTE
      *CIS
       PROCEDURE DIVISION.
      *CIE

       0000-INITIALIZE.
              IF HAVE-MESSAGE-PROP                                      C123840
                 PERFORM 2035-CRT-MESG-HANDLE                           C123840
                 PERFORM 2035-SET-MESG-PROP                             C123840
              END-IF.                                                   C123840
              PERFORM 2300-DO-CONSUMER-PUT
        2035-MSG-PROP-DEL.                                              C123840
            MOVE MQDMPO-DEL-FIRST TO MQDMPO-OPTIONS.                    C123840
            MOVE MQDMPO-CURRENT-VERSION TO MQDMPO-VERSION.              C123840
            CALL 'CSQBDTMP' USING WS-CON-HANDLE                         C123840
                                  WS-MESSAGE-HANDLE                     C123840
                                  MQM-DELETE-MESSPROP-OPTIONS           C123840
                                  MQM-SET-PROPERTY-NAME                 C123840
                                  WS-COMP-CODE                          C123840
                                  WS-REASON-CODE.                       C123840
        2035-CRT-MESG-HANDLE.                                           C123840
             MOVE MQMI-NONE TO MQMD-MSGID.                              C123840
                  MOVE MQCI-NONE TO MQMD-CORRELID.                      C123840
      *CREATE A MESSAGE HANDLE TO STORE THE COPY MESSAGE PROPERTY       C123840
      *BT    CALL 'CSQBCTMH' USING WS-CON-HANDLE                        C123840
      *CI    CALL 'CSQCCTMH' USING WS-CON-HANDLE                        C123840
                            MQM-CRT-MSG-HNDLE-OPTIONS                   C123840
                            WS-MESSAGE-HANDLE                           C123840
                            WS-COMP-CODE                                C123840
                            WS-REASON-CODE.                             C123840
             IF WS-COMP-CODE NOT EQUAL 0                                C123840
                MOVE 'SMSGHDO2' TO errorProgram                         C123840
                    MOVE 'FATAL'    TO errorMessageType                 C123840
                    MOVE SE-CTMH-ERROR-CODE  TO errorCode               C123840
                    MOVE SE-CTMH-ERROR-DESC  TO errorMessage            C123840
      *CI           PERFORM 2400-DO-ERROR                               C123840
                    PERFORM 2400-EXIT                                   C123840
             END-IF.                                                    C123840
        2035-SET-MESG-PROP.                                             C123840
      *For each name value message property combination issue the       C123840
      *Set message properties call                                      C123840
            PERFORM VARYING WS-I1 FROM 1 BY 1 UNTIL                     C123840
                    WS-I1  > PROP-COUNT                                 C123840
            COMPUTE MQSMPO-OPTIONS = MQSMPO-SET-FIRST                   C123840
      *BTS                                                              C123840
            INITIALIZE WS-PROP-NAME                                     C123840
            MOVE PROP-NAME(WS-I1) TO WS-PROP-NAME                       C123840
            SET MQCHARV-VSPTR TO ADDRESS OF WS-PROP-NAME                C123840
      *BTE                                                              C123840
      *CI   SET MQCHARV-VSPTR TO ADDRESS OF PROP-NAME(WS-I1)            C123840
            MOVE LNGTH-PROP-NAME(WS-I1) TO MQCHARV-VSBUFSIZE            C123840
                                              MQCHARV-VSLENGTH          C123840
            COMPUTE MQPD-CONTEXT = PROP-CONTEXT(WS-I1)                  C123840
            MOVE MQPMO-CURRENT-VERSION TO MQPMO-VERSION                 C123840
            MOVE LNGHT-MESG-PROP(WS-I1)to                               C123840
                 WS-PROPERTY-VALUE-LNTH                                 C123840
      *CI   CALL 'CSQCSTMP' USING WS-CON-HANDLE                         C123840
      *BT   CALL 'CSQBSTMP' USING WS-CON-HANDLE                         C123840
                                  WS-MESSAGE-HANDLE                     C123840
                                  MQM-SET-MESSAGE-OPTIONS               C123840
                                  MQM-SET-PROPERTY-NAME                 C123840
                                  MQM-SET-PROPERTY-DESCRIPTOR           C123840
                                  PROPERTY-TYPE(WS-I1)                  C123840
                                  WS-PROPERTY-VALUE-LNTH                C123840
                                  MESG-PROP(WS-I1)                      C123840
                                  WS-COMP-CODE                          C123840
                                  WS-REASON-CODE                        C123840
              IF WS-COMP-CODE NOT EQUAL 0                               C123840
               MOVE 'SMSGHDO2' TO errorProgram                          C123840
                   MOVE 'FATAL'    TO errorMessageType                  C123840
                   MOVE SE-STMP-ERROR-CODE  TO errorCode                C123840
                   MOVE SE-STMP-ERROR-DESC  TO errorMessage             C123840
      *CI          PERFORM 2400-DO-ERROR                                C123840
                   PERFORM 2400-EXIT                                    C123840
               END-IF                                                   C123840
             END-PERFORM.                                               C123840
             
             
             Before the put some message will have message properties some will not hence this code 
             
             IF HAVE-MESSAGE-PROP OR SAME-MESG-PROP-PREV         
	        MOVE WS-MESSAGE-HANDLE TO MQPMO-ORIGINALMSGHANDLE
	        MOVE MQACTP-NEW      TO  MQPMO-ACTION            
	     ELSE                                                
	        MOVE ZERO TO MQPMO-ORIGINALMSGHANDLE             
	                     MQPMO-ACTION                        
END-IF.                                             
